"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JobStatusOptionsMap = exports.JobStatusOptions = exports.JOB_STATUS = exports.ExecutionStatusOptionsMap = exports.ExecutionStatusOptions = exports.EXECUTION_STATUS = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _icons() {
  const data = require("@ant-design/icons");
  _icons = function _icons() {
    return data;
  };
  return data;
}
var _locale = require("./locale");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const EXECUTION_STATUS = {
  QUEUEING: null,
  STARTED: 0,
  RESOLVED: 1,
  FAILED: -1,
  ERROR: -2,
  ABORTED: -3,
  CANCELED: -4,
  REJECTED: -5
};
exports.EXECUTION_STATUS = EXECUTION_STATUS;
const ExecutionStatusOptions = [{
  value: EXECUTION_STATUS.QUEUEING,
  label: `{{t("Queueing", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'blue'
}, {
  value: EXECUTION_STATUS.STARTED,
  label: `{{t("On going", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'gold'
}, {
  value: EXECUTION_STATUS.RESOLVED,
  label: `{{t("Resolved", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'green'
}, {
  value: EXECUTION_STATUS.FAILED,
  label: `{{t("Failed", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'red'
}, {
  value: EXECUTION_STATUS.ERROR,
  label: `{{t("Error", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'red'
}, {
  value: EXECUTION_STATUS.ABORTED,
  label: `{{t("Aborted", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'red'
}, {
  value: EXECUTION_STATUS.CANCELED,
  label: `{{t("Canceled", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'volcano'
}, {
  value: EXECUTION_STATUS.REJECTED,
  label: `{{t("Rejected", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'volcano'
}];
exports.ExecutionStatusOptions = ExecutionStatusOptions;
const ExecutionStatusOptionsMap = ExecutionStatusOptions.reduce((map, option) => Object.assign(map, {
  [option.value]: option
}), {});
exports.ExecutionStatusOptionsMap = ExecutionStatusOptionsMap;
const JOB_STATUS = {
  PENDING: 0,
  RESOLVED: 1,
  FAILED: -1,
  ERROR: -2,
  ABORTED: -3,
  CANCELED: -4,
  REJECTED: -5
};
exports.JOB_STATUS = JOB_STATUS;
const JobStatusOptions = [{
  value: JOB_STATUS.PENDING,
  label: `{{t("Pending", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'gold',
  icon: _react().default.createElement(_icons().ClockCircleOutlined, null)
}, {
  value: JOB_STATUS.RESOLVED,
  label: `{{t("Resolved", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'green',
  icon: _react().default.createElement(_icons().CheckOutlined, null)
}, {
  value: JOB_STATUS.FAILED,
  label: `{{t("Failed", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'red',
  icon: _react().default.createElement(_icons().ExclamationOutlined, null)
}, {
  value: JOB_STATUS.ERROR,
  label: `{{t("Error", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'red',
  icon: _react().default.createElement(_icons().CloseOutlined, null)
}, {
  value: JOB_STATUS.ABORTED,
  label: `{{t("Aborted", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'red',
  icon: _react().default.createElement(_icons().MinusOutlined, {
    rotate: 90
  })
}, {
  value: JOB_STATUS.CANCELED,
  label: `{{t("Canceled", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'volcano',
  icon: _react().default.createElement(_icons().MinusOutlined, {
    rotate: 45
  })
}, {
  value: JOB_STATUS.REJECTED,
  label: `{{t("Rejected", { ns: "${_locale.NAMESPACE}" })}}`,
  color: 'volcano',
  icon: _react().default.createElement(_icons().MinusOutlined, null)
}];
exports.JobStatusOptions = JobStatusOptions;
const JobStatusOptionsMap = JobStatusOptions.reduce((map, option) => Object.assign(map, {
  [option.value]: option
}), {});
exports.JobStatusOptionsMap = JobStatusOptionsMap;