"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _Duration = _interopRequireDefault(require("../components/Duration"));
var _constants = require("../constants");
var _locale = require("../locale");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _default = {
  title: `{{t("Delay", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'delay',
  group: 'control',
  description: `{{t("Delay a period of time and then continue or exit the process. Can be used to set wait or timeout times in parallel branches.", { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    duration: {
      type: 'number',
      title: `{{t("Duration", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Duration',
      default: 60000,
      required: true
    },
    endStatus: {
      type: 'number',
      title: `{{t("End Status", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Radio.Group',
      enum: [{
        label: `{{t("Succeed and continue", { ns: "${_locale.NAMESPACE}" })}}`,
        value: _constants.JOB_STATUS.RESOLVED
      }, {
        label: `{{t("Fail and exit", { ns: "${_locale.NAMESPACE}" })}}`,
        value: _constants.JOB_STATUS.FAILED
      }],
      required: true,
      default: _constants.JOB_STATUS.RESOLVED
    }
  },
  view: {},
  scope: {},
  components: {
    Duration: _Duration.default
  }
};
exports.default = _default;