import { SchemaInitializerItemOptions, useCollectionDataSource } from '@nocobase/client';
import { CollectionFieldInitializers } from '../components/CollectionFieldInitializers';
import { FilterDynamicComponent } from '../components/FilterDynamicComponent';
declare const _default: {
    title: string;
    type: string;
    group: string;
    description: string;
    fieldset: {
        collection: {
            type: string;
            title: string;
            required: boolean;
            'x-reactions': any[];
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                dropdownMatchSelectWidth: boolean;
            };
        };
        multiple: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            description: string;
        };
        params: {
            type: string;
            properties: {
                filter: {
                    type: string;
                    title: string;
                    'x-decorator': string;
                    'x-component': string;
                    'x-component-props': {
                        useProps(): {
                            options: any[];
                            className: string;
                        };
                        dynamicComponent: string;
                    };
                };
                appends: {
                    type: string;
                    title: string;
                    description: string;
                    'x-decorator': string;
                    'x-component': string;
                    'x-component-props': {
                        mode: string;
                        placeholder: string;
                        filter(field: any): boolean;
                    };
                    'x-reactions': {
                        dependencies: string[];
                        fulfill: {
                            state: {
                                visible: string;
                            };
                        };
                    }[];
                };
            };
        };
        failOnEmpty: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
        };
    };
    view: {};
    scope: {
        useCollectionDataSource: typeof useCollectionDataSource;
    };
    components: {
        FilterDynamicComponent: typeof FilterDynamicComponent;
        FieldsSelect: import("react").MemoExoticComponent<import("react").FunctionComponent<Pick<any, string | number | symbol>>>;
    };
    useVariables({ config }: {
        config: any;
    }, options: any): import("../variable").VariableOption[];
    useInitializers(node: any): SchemaInitializerItemOptions | null;
    initializers: {
        CollectionFieldInitializers: typeof CollectionFieldInitializers;
    };
};
export default _default;
