"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _collection = require("../schemas/collection");
var _locale = require("../locale");
var _CollectionBlockInitializer = require("../components/CollectionBlockInitializer");
var _CollectionFieldInitializers = require("../components/CollectionFieldInitializers");
var _FilterDynamicComponent = require("../components/FilterDynamicComponent");
var _variable = require("../variable");
var _FieldsSelect = require("../components/FieldsSelect");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var _default = {
  title: `{{t("Query record", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'query',
  group: 'collection',
  description: `{{t("Query records from a collection. You can use variables from upstream nodes as query conditions.", { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    collection: _collection.collection,
    multiple: {
      type: 'boolean',
      title: `{{t("Allow multiple records as result", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Checkbox',
      description: `{{t("If checked, when there are multiple records in the query result, an array will be returned as the result, which can be operated on one by one using a loop node. Otherwise, only one record will be returned.", { ns: "${_locale.NAMESPACE}" })}}`
    },
    params: {
      type: 'object',
      properties: {
        filter: _collection.filter,
        appends: _collection.appends
      }
    },
    failOnEmpty: {
      type: 'boolean',
      title: `{{t("Exit when query result is null", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Checkbox'
    }
  },
  view: {},
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    FilterDynamicComponent: _FilterDynamicComponent.FilterDynamicComponent,
    FieldsSelect: _FieldsSelect.FieldsSelect
  },
  useVariables({
    config
  }, options) {
    var _options$depth, _config$params, _config$params$append;
    const result = (0, _variable.useCollectionFieldOptions)(_objectSpread(_objectSpread({
      collection: config === null || config === void 0 ? void 0 : config.collection
    }, options), {}, {
      depth: ((_options$depth = options === null || options === void 0 ? void 0 : options.depth) !== null && _options$depth !== void 0 ? _options$depth : config === null || config === void 0 ? void 0 : (_config$params = config.params) === null || _config$params === void 0 ? void 0 : (_config$params$append = _config$params.appends) === null || _config$params$append === void 0 ? void 0 : _config$params$append.length) ? 1 : 0
    }));
    return (result === null || result === void 0 ? void 0 : result.length) ? result : null;
  },
  useInitializers(node) {
    var _node$title;
    if (!node.config.collection) {
      return null;
    }
    return {
      type: 'item',
      title: (_node$title = node.title) !== null && _node$title !== void 0 ? _node$title : `#${node.id}`,
      component: _CollectionBlockInitializer.CollectionBlockInitializer,
      collection: node.config.collection,
      dataSource: `{{$jobsMapByNodeId.${node.id}}}`
    };
  },
  initializers: {
    CollectionFieldInitializers: _CollectionFieldInitializers.CollectionFieldInitializers
  }
};
exports.default = _default;