import { SchemaInitializerItemOptions, useCollectionDataSource } from '@nocobase/client';
import { CollectionFieldInitializers } from '../components/CollectionFieldInitializers';
declare const _default: {
    title: string;
    type: string;
    fieldset: {
        collection: {
            "x-reactions": any[];
            type: string;
            title: string;
            required: boolean;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                dropdownMatchSelectWidth: boolean;
            };
        };
        mode: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                dropdownMatchSelectWidth: boolean;
                options: {
                    label: string;
                    value: number;
                }[];
                placeholder: string;
            };
            required: boolean;
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
        };
        changed: {
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                mode: string;
                placeholder: string;
                filter(field: any): boolean;
            };
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
        };
        condition: {
            title: string;
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
            type: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                useProps(): {
                    options: any[];
                    className: string;
                };
                dynamicComponent: string;
            };
        };
        appends: {
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                mode: string;
                placeholder: string;
                filter(field: any): boolean;
            };
        };
    };
    scope: {
        useCollectionDataSource: typeof useCollectionDataSource;
    };
    components: {
        FieldsSelect: import("react").MemoExoticComponent<import("react").FunctionComponent<Pick<any, string | number | symbol>>>;
    };
    useVariables(config: any, options: any): import("../variable").VariableOption[];
    useInitializers(config: any): SchemaInitializerItemOptions | null;
    initializers: {
        CollectionFieldInitializers: typeof CollectionFieldInitializers;
    };
};
export default _default;
