"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _collection = require("../schemas/collection");
var _variable = require("../variable");
var _CollectionBlockInitializer = require("../components/CollectionBlockInitializer");
var _CollectionFieldInitializers = require("../components/CollectionFieldInitializers");
var _locale = require("../locale");
var _FieldsSelect = require("../components/FieldsSelect");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
const COLLECTION_TRIGGER_MODE = {
  CREATED: 1,
  UPDATED: 2,
  SAVED: 3,
  DELETED: 4
};
const collectionModeOptions = [{
  label: `{{t("After record added", { ns: "${_locale.NAMESPACE}" })}}`,
  value: COLLECTION_TRIGGER_MODE.CREATED
}, {
  label: `{{t("After record updated", { ns: "${_locale.NAMESPACE}" })}}`,
  value: COLLECTION_TRIGGER_MODE.UPDATED
}, {
  label: `{{t("After record added or updated", { ns: "${_locale.NAMESPACE}" })}}`,
  value: COLLECTION_TRIGGER_MODE.SAVED
}, {
  label: `{{t("After record deleted", { ns: "${_locale.NAMESPACE}" })}}`,
  value: COLLECTION_TRIGGER_MODE.DELETED
}];
var _default = {
  title: `{{t("Collection event", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'collection',
  fieldset: {
    collection: _objectSpread(_objectSpread({}, _collection.collection), {}, {
      ['x-reactions']: [..._collection.collection['x-reactions'], {
        target: 'changed',
        effects: ['onFieldValueChange'],
        fulfill: {
          state: {
            value: []
          }
        }
      }, {
        target: 'condition',
        effects: ['onFieldValueChange'],
        fulfill: {
          state: {
            value: null
          }
        }
      }]
    }),
    mode: {
      type: 'number',
      title: `{{t("Trigger on", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      'x-component-props': {
        dropdownMatchSelectWidth: false,
        options: collectionModeOptions,
        placeholder: `{{t("Trigger on", { ns: "${_locale.NAMESPACE}" })}}`
      },
      required: true,
      'x-reactions': [{
        dependencies: ['collection'],
        fulfill: {
          state: {
            visible: '{{!!$deps[0]}}'
          }
        }
      }]
    },
    changed: {
      type: 'array',
      title: `{{t("Changed fields", { ns: "${_locale.NAMESPACE}" })}}`,
      description: `{{t("Triggered only if one of the selected fields changes. If unselected, it means that it will be triggered when any field changes. When record is added or deleted, any field is considered to have been changed.", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'FieldsSelect',
      'x-component-props': {
        mode: 'multiple',
        placeholder: '{{t("Select Field")}}',
        filter(field) {
          return !field.hidden && (field.uiSchema ? !field.uiSchema['x-read-pretty'] : true) && !['linkTo', 'hasOne', 'hasMany', 'belongsToMany'].includes(field.type);
        }
      },
      'x-reactions': [{
        dependencies: ['collection', 'mode'],
        fulfill: {
          state: {
            visible: `{{!!$deps[0] && ($deps[1] & ${COLLECTION_TRIGGER_MODE.UPDATED})}}`
          }
        }
      }]
    },
    condition: _objectSpread(_objectSpread({}, _collection.filter), {}, {
      title: `{{t("Only triggers when match conditions", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-reactions': [{
        dependencies: ['collection'],
        fulfill: {
          state: {
            visible: '{{!!$deps[0]}}'
          }
        }
      }]
    }),
    appends: _objectSpread(_objectSpread({}, _collection.appends), {}, {
      'x-reactions': [..._collection.appends['x-reactions'], {
        dependencies: ['mode'],
        fulfill: {
          state: {
            visible: `{{!($deps[0] & ${COLLECTION_TRIGGER_MODE.DELETED})}}`
          }
        }
      }]
    })
  },
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    FieldsSelect: _FieldsSelect.FieldsSelect
  },
  useVariables(config, options) {
    var _options$depth, _config$appends;
    const _useWorkflowTranslati = (0, _locale.useWorkflowTranslation)(),
      t = _useWorkflowTranslati.t;
    const rootFields = [{
      collectionName: config.collection,
      name: 'data',
      type: 'hasOne',
      target: config.collection,
      uiSchema: {
        title: t('Trigger data')
      }
    }];
    const result = (0, _variable.useCollectionFieldOptions)(_objectSpread(_objectSpread({}, options), {}, {
      fields: rootFields,
      depth: (_options$depth = options === null || options === void 0 ? void 0 : options.depth) !== null && _options$depth !== void 0 ? _options$depth : ((_config$appends = config.appends) === null || _config$appends === void 0 ? void 0 : _config$appends.length) ? 2 : 1
    }));
    return result;
  },
  useInitializers(config) {
    if (!config.collection) {
      return null;
    }
    return {
      type: 'item',
      key: 'triggerData',
      title: `{{t("Trigger data", { ns: "${_locale.NAMESPACE}" })}}`,
      component: _CollectionBlockInitializer.CollectionBlockInitializer,
      collection: config.collection,
      dataSource: '{{$context.data}}'
    };
  },
  initializers: {
    CollectionFieldInitializers: _CollectionFieldInitializers.CollectionFieldInitializers
  }
};
exports.default = _default;