import { Plugin } from '@nocobase/server';
import { Registry } from '@nocobase/utils';
import { Instruction } from './instructions';
import ExecutionModel from './models/Execution';
import WorkflowModel from './models/Workflow';
import Processor from './Processor';
import { Trigger } from './triggers';
import { CustomFunction } from './functions';
import { Logger } from '@nocobase/logger';
declare type ID = number | string;
export default class WorkflowPlugin extends Plugin {
    instructions: Registry<Instruction>;
    triggers: Registry<Trigger>;
    functions: Registry<CustomFunction>;
    private executing;
    private pending;
    private events;
    private loggerCache;
    getLogger(workflowId: ID): Logger;
    onBeforeSave: (instance: WorkflowModel, options: any) => Promise<void>;
    load(): Promise<void>;
    toggle(workflow: WorkflowModel, enable?: boolean): void;
    trigger(workflow: WorkflowModel, context: {
        [key: string]: any;
    }, options?: {
        context?: any;
    }): void;
    private prepare;
    resume(job: any): Promise<void>;
    private dispatch;
    private process;
    createProcessor(execution: ExecutionModel, options?: {}): Processor;
}
export {};
