"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _database() {
  const data = require("@nocobase/database");
  _database = function _database() {
    return data;
  };
  return data;
}
function _evaluators() {
  const data = require("@nocobase/evaluators");
  _evaluators = function _evaluators() {
    return data;
  };
  return data;
}
function _utils() {
  const data = require("@nocobase/utils");
  _utils = function _utils() {
    return data;
  };
  return data;
}
var _constants = require("./constants");
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
class Processor {
  constructor(execution, options) {
    this.execution = void 0;
    this.options = void 0;
    this.logger = void 0;
    this.transaction = void 0;
    this.nodes = [];
    this.nodesMap = new Map();
    this.jobsMap = new Map();
    this.jobsMapByNodeId = {};
    this.execution = execution;
    this.options = options;
    this.logger = options.plugin.getLogger(execution.workflowId);
  }
  // make dual linked nodes list then cache
  makeNodes(nodes = []) {
    this.nodes = nodes;
    nodes.forEach(node => {
      this.nodesMap.set(node.id, node);
    });
    nodes.forEach(node => {
      if (node.upstreamId) {
        node.upstream = this.nodesMap.get(node.upstreamId);
      }
      if (node.downstreamId) {
        node.downstream = this.nodesMap.get(node.downstreamId);
      }
    });
  }
  makeJobs(jobs) {
    jobs.forEach(job => {
      this.jobsMap.set(job.id, job);
      // TODO: should consider cycle, and from previous job
      this.jobsMapByNodeId[job.nodeId] = job.result;
    });
  }
  getTransaction() {
    var _this = this;
    return _asyncToGenerator(function* () {
      if (!_this.execution.useTransaction) {
        return;
      }
      const options = _this.options;
      // @ts-ignore
      return options.transaction && !options.transaction.finished ? options.transaction : yield options.plugin.db.sequelize.transaction();
    })();
  }
  prepare() {
    var _this2 = this;
    return _asyncToGenerator(function* () {
      const transaction = yield _this2.getTransaction();
      _this2.transaction = transaction;
      const execution = _this2.execution;
      if (!execution.workflow) {
        execution.workflow = yield execution.getWorkflow({
          transaction
        });
      }
      const nodes = yield execution.workflow.getNodes({
        transaction
      });
      _this2.makeNodes(nodes);
      const jobs = yield execution.getJobs({
        order: [['id', 'ASC']],
        transaction
      });
      _this2.makeJobs(jobs);
    })();
  }
  start() {
    var _this3 = this;
    return _asyncToGenerator(function* () {
      const execution = _this3.execution;
      if (execution.status !== _constants.EXECUTION_STATUS.STARTED) {
        throw new Error(`execution was ended with status ${execution.status}`);
      }
      yield _this3.prepare();
      if (_this3.nodes.length) {
        const head = _this3.nodes.find(item => !item.upstream);
        yield _this3.run(head, {
          result: execution.context
        });
      } else {
        yield _this3.exit(null);
      }
      yield _this3.commit();
    })();
  }
  resume(job) {
    var _this4 = this;
    return _asyncToGenerator(function* () {
      const execution = _this4.execution;
      if (execution.status !== _constants.EXECUTION_STATUS.STARTED) {
        throw new Error(`execution was ended with status ${execution.status}`);
      }
      yield _this4.prepare();
      const node = _this4.nodesMap.get(job.nodeId);
      yield _this4.recall(node, job);
      yield _this4.commit();
    })();
  }
  commit() {
    var _this5 = this;
    return _asyncToGenerator(function* () {
      // @ts-ignore
      if (_this5.transaction && (!_this5.options.transaction || _this5.options.transaction.finished)) {
        yield _this5.transaction.commit();
      }
    })();
  }
  exec(instruction, node, prevJob) {
    var _this6 = this;
    return _asyncToGenerator(function* () {
      let job;
      try {
        // call instruction to get result and status
        _this6.logger.info(`execution (${_this6.execution.id}) run instruction [${node.type}] for node (${node.id})`);
        _this6.logger.debug(`config of node`, {
          data: node.config
        });
        job = yield instruction(node, prevJob, _this6);
        if (!job) {
          return null;
        }
      } catch (err) {
        // for uncaught error, set to error
        _this6.logger.error(`execution (${_this6.execution.id}) run instruction [${node.type}] for node (${node.id}) failed: `, {
          error: err
        });
        job = {
          result: err instanceof Error ? {
            message: err.message,
            stack: process.env.NODE_ENV === 'production' ? [] : err.stack
          } : err,
          status: _constants.JOB_STATUS.ERROR
        };
        // if previous job is from resuming
        if (prevJob && prevJob.nodeId === node.id) {
          prevJob.set(job);
          job = prevJob;
        }
      }
      if (!(job instanceof _database().Model)) {
        job.upstreamId = prevJob instanceof _database().Model ? prevJob.get('id') : null;
        job.nodeId = node.id;
      }
      const savedJob = yield _this6.saveJob(job);
      _this6.logger.info(`execution (${_this6.execution.id}) run instruction [${node.type}] for node (${node.id}) finished as status: ${savedJob.status}`);
      _this6.logger.debug(`result of node`, {
        data: savedJob.result
      });
      if (savedJob.status === _constants.JOB_STATUS.RESOLVED && node.downstream) {
        // run next node
        _this6.logger.debug(`run next node (${node.downstreamId})`);
        return _this6.run(node.downstream, savedJob);
      }
      // all nodes in scope have been executed
      return _this6.end(node, savedJob);
    })();
  }
  run(node, input) {
    var _this7 = this;
    return _asyncToGenerator(function* () {
      const instructions = _this7.options.plugin.instructions;
      const instruction = instructions.get(node.type);
      if (typeof instruction.run !== 'function') {
        return Promise.reject(new Error('`run` should be implemented for customized execution of the node'));
      }
      return _this7.exec(instruction.run.bind(instruction), node, input);
    })();
  }
  // parent node should take over the control
  end(node, job) {
    var _this8 = this;
    return _asyncToGenerator(function* () {
      _this8.logger.debug(`branch ended at node (${node.id})`);
      const parentNode = _this8.findBranchParentNode(node);
      // no parent, means on main flow
      if (parentNode) {
        _this8.logger.debug(`not on main, recall to parent entry node (${node.id})})`);
        yield _this8.recall(parentNode, job);
        return job;
      }
      // really done for all nodes
      // * should mark execution as done with last job status
      return _this8.exit(job);
    })();
  }
  recall(node, job) {
    var _this9 = this;
    return _asyncToGenerator(function* () {
      const instructions = _this9.options.plugin.instructions;
      const instruction = instructions.get(node.type);
      if (typeof instruction.resume !== 'function') {
        return Promise.reject(new Error('`resume` should be implemented'));
      }
      return _this9.exec(instruction.resume.bind(instruction), node, job);
    })();
  }
  exit(job) {
    var _this10 = this;
    return _asyncToGenerator(function* () {
      var _this10$constructor$S;
      const status = job ? (_this10$constructor$S = _this10.constructor.StatusMap[job.status]) !== null && _this10$constructor$S !== void 0 ? _this10$constructor$S : Math.sign(job.status) : _constants.EXECUTION_STATUS.RESOLVED;
      _this10.logger.info(`execution (${_this10.execution.id}) all nodes finished, finishing execution...`);
      yield _this10.execution.update({
        status
      }, {
        transaction: _this10.transaction
      });
      return null;
    })();
  }
  // TODO(optimize)
  saveJob(payload) {
    var _this11 = this;
    return _asyncToGenerator(function* () {
      const database = _this11.execution.constructor.database;
      const _database$getCollecti = database.getCollection('jobs'),
        model = _database$getCollecti.model;
      let job;
      if (payload instanceof model) {
        job = yield payload.save({
          transaction: _this11.transaction
        });
      } else if (payload.id) {
        var _yield$model$update = yield model.update(payload, {
          where: {
            id: payload.id
          },
          returning: true,
          transaction: _this11.transaction
        });
        var _yield$model$update2 = _slicedToArray(_yield$model$update, 1);
        job = _yield$model$update2[0];
      } else {
        job = yield model.create(_objectSpread(_objectSpread({}, payload), {}, {
          executionId: _this11.execution.id
        }), {
          transaction: _this11.transaction
        });
      }
      _this11.jobsMap.set(job.id, job);
      _this11.jobsMapByNodeId[job.nodeId] = job.result;
      return job;
    })();
  }
  getBranches(node) {
    return this.nodes.filter(item => item.upstream === node && item.branchIndex !== null).sort((a, b) => Number(a.branchIndex) - Number(b.branchIndex));
  }
  // find the first node in current branch
  findBranchStartNode(node, parent) {
    for (let n = node; n; n = n.upstream) {
      if (!parent) {
        if (n.branchIndex !== null) {
          return n;
        }
      } else {
        if (n.upstream === parent) {
          return n;
        }
      }
    }
    return null;
  }
  // find the node start current branch
  findBranchParentNode(node) {
    for (let n = node; n; n = n.upstream) {
      if (n.branchIndex !== null) {
        return n.upstream;
      }
    }
    return null;
  }
  findBranchEndNode(node) {
    for (let n = node; n; n = n.downstream) {
      if (!n.downstream) {
        return n;
      }
    }
    return null;
  }
  findBranchParentJob(job, node) {
    for (let j = job; j; j = this.jobsMap.get(j.upstreamId)) {
      if (j.nodeId === node.id) {
        return j;
      }
    }
    return null;
  }
  findBranchLastJob(node) {
    for (let n = this.findBranchEndNode(node); n && n !== node.upstream; n = n.upstream) {
      const jobs = Array.from(this.jobsMap.values()).filter(item => item.nodeId === n.id).sort((a, b) => a.createdAt.getTime() - b.createdAt.getTime());
      if (jobs.length) {
        return jobs[jobs.length - 1];
      }
    }
    return null;
  }
  getScope(node) {
    const systemFns = {};
    const scope = {
      execution: this.execution,
      node
    };
    var _iterator = _createForOfIteratorHelper(this.options.plugin.functions.getEntities()),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        const _step$value = _slicedToArray(_step.value, 2),
          name = _step$value[0],
          fn = _step$value[1];
        systemFns[name] = fn.bind(scope);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    const $scopes = {};
    if (node) {
      for (let n = this.findBranchParentNode(node); n; n = this.findBranchParentNode(n)) {
        const instruction = this.options.plugin.instructions.get(n.type);
        if (typeof instruction.getScope === 'function') {
          $scopes[n.id] = instruction.getScope(n, this.jobsMapByNodeId[n.id], this);
        }
      }
    }
    return {
      $context: this.execution.context,
      $jobsMapByNodeId: this.jobsMapByNodeId,
      $system: systemFns,
      $scopes
    };
  }
  getParsedValue(value, node) {
    const template = (0, _utils().parse)(value);
    const scope = this.getScope(node);
    template.parameters.forEach(({
      key
    }) => {
      (0, _evaluators().appendArrayColumn)(scope, key);
    });
    return template(scope);
  }
}
exports.default = Processor;
Processor.StatusMap = {
  [_constants.JOB_STATUS.PENDING]: _constants.EXECUTION_STATUS.STARTED,
  [_constants.JOB_STATUS.RESOLVED]: _constants.EXECUTION_STATUS.RESOLVED,
  [_constants.JOB_STATUS.FAILED]: _constants.EXECUTION_STATUS.FAILED,
  [_constants.JOB_STATUS.ERROR]: _constants.EXECUTION_STATUS.ERROR,
  [_constants.JOB_STATUS.ABORTED]: _constants.EXECUTION_STATUS.ABORTED,
  [_constants.JOB_STATUS.CANCELED]: _constants.EXECUTION_STATUS.CANCELED,
  [_constants.JOB_STATUS.REJECTED]: _constants.EXECUTION_STATUS.REJECTED
};