"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _evaluators() {
  const data = require("@nocobase/evaluators");
  _evaluators = function _evaluators() {
    return data;
  };
  return data;
}
function _utils() {
  const data = require("@nocobase/utils");
  _utils = function _utils() {
    return data;
  };
  return data;
}
var _constants = require("../constants");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
var _default = {
  run(node, prevJob, processor) {
    return _asyncToGenerator(function* () {
      const _ref = node.config || {},
        _ref$dynamic = _ref.dynamic,
        dynamic = _ref$dynamic === void 0 ? false : _ref$dynamic;
      let _node$config = node.config,
        _node$config$engine = _node$config.engine,
        engine = _node$config$engine === void 0 ? 'math.js' : _node$config$engine,
        _node$config$expressi = _node$config.expression,
        expression = _node$config$expressi === void 0 ? '' : _node$config$expressi;
      let scope = processor.getScope(node);
      if (dynamic) {
        var _parse, _parse2, _node$config$scope;
        const parsed = (_parse = (0, _utils().parse)(dynamic)(scope)) !== null && _parse !== void 0 ? _parse : {};
        engine = parsed.engine;
        expression = parsed.expression;
        scope = (_parse2 = (0, _utils().parse)((_node$config$scope = node.config.scope) !== null && _node$config$scope !== void 0 ? _node$config$scope : '')(scope)) !== null && _parse2 !== void 0 ? _parse2 : {};
      }
      const evaluator = _evaluators().evaluators.get(engine);
      try {
        const result = evaluator && expression ? evaluator(expression, scope) : null;
        return {
          result,
          status: _constants.JOB_STATUS.RESOLVED
        };
      } catch (e) {
        return {
          result: e.toString(),
          status: _constants.JOB_STATUS.ERROR
        };
      }
    })();
  }
};
exports.default = _default;