"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _constants = require("../constants");
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function getTargetLength(target) {
  let length = 0;
  if (typeof target === 'number') {
    if (target < 0) {
      throw new Error('Loop target in number type must be greater than 0');
    }
    length = Math.floor(target);
  } else {
    const targets = (Array.isArray(target) ? target : [target]).filter(t => t != null);
    length = targets.length;
  }
  return length;
}
var _default = {
  run(node, prevJob, processor) {
    return _asyncToGenerator(function* () {
      var _prevJob$id;
      const _processor$getBranche = processor.getBranches(node),
        _processor$getBranche2 = _slicedToArray(_processor$getBranche, 1),
        branch = _processor$getBranche2[0];
      const target = processor.getParsedValue(node.config.target, node);
      const length = getTargetLength(target);
      if (!branch || !length) {
        return {
          status: _constants.JOB_STATUS.RESOLVED,
          result: 0
        };
      }
      const job = yield processor.saveJob({
        status: _constants.JOB_STATUS.PENDING,
        // save loop index
        result: 0,
        nodeId: node.id,
        upstreamId: (_prevJob$id = prevJob === null || prevJob === void 0 ? void 0 : prevJob.id) !== null && _prevJob$id !== void 0 ? _prevJob$id : null
      });
      // TODO: add loop scope to stack
      // processor.stack.push({
      //   label: node.title,
      //   value: node.id
      // });
      yield processor.run(branch, job);
      return null;
    })();
  },
  resume(node, branchJob, processor) {
    return _asyncToGenerator(function* () {
      const job = processor.findBranchParentJob(branchJob, node);
      const loop = processor.nodesMap.get(job.nodeId);
      const _processor$getBranche3 = processor.getBranches(node),
        _processor$getBranche4 = _slicedToArray(_processor$getBranche3, 1),
        branch = _processor$getBranche4[0];
      const result = job.result,
        status = job.status;
      // if loop has been done (resolved / rejected), do not care newly executed branch jobs.
      if (status !== _constants.JOB_STATUS.PENDING) {
        return null;
      }
      const nextIndex = result + 1;
      const target = processor.getParsedValue(loop.config.target, node);
      // branchJob.status === JOB_STATUS.RESOLVED means branchJob is done, try next loop or exit as resolved
      if (branchJob.status > _constants.JOB_STATUS.PENDING) {
        job.set({
          result: nextIndex
        });
        const length = getTargetLength(target);
        if (nextIndex < length) {
          yield processor.saveJob(job);
          yield processor.run(branch, job);
          return null;
        }
      }
      // branchJob.status < JOB_STATUS.PENDING means branchJob is rejected, any rejection should cause loop rejected
      job.set({
        status: branchJob.status
      });
      return job;
    })();
  },
  getScope(node, index, processor) {
    const target = processor.getParsedValue(node.config.target, node);
    const targets = (Array.isArray(target) ? target : [target]).filter(t => t != null);
    const length = getTargetLength(target);
    const item = typeof target === 'number' ? index : targets[index];
    const result = {
      item,
      index,
      length
    };
    return result;
  }
};
exports.default = _default;