"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.submit = submit;
function _actions() {
  const data = require("@nocobase/actions");
  _actions = function _actions() {
    return data;
  };
  return data;
}
var _constants = require("../../constants");
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function submit(_x, _x2) {
  return _submit.apply(this, arguments);
}
function _submit() {
  _submit = _asyncToGenerator(function* (context, next) {
    const repository = _actions().utils.getRepositoryFromParams(context);
    const _context$action$param = context.action.params,
      filterByTk = _context$action$param.filterByTk,
      values = _context$action$param.values;
    const currentUser = context.state.currentUser;
    if (!currentUser) {
      return context.throw(401);
    }
    const plugin = context.app.pm.get('workflow');
    const userJob = yield context.db.sequelize.transaction( /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (transaction) {
        var _values$result, _forms$form, _forms$form$actions, _instance$node$config2;
        const instance = yield repository.findOne({
          filterByTk,
          // filter: {
          //   userId: currentUser?.id
          // },
          appends: ['job', 'node', 'execution', 'workflow'],
          context,
          transaction
        });
        if (!instance) {
          return context.throw(404);
        }
        const _instance$node$config = instance.node.config.forms,
          forms = _instance$node$config === void 0 ? {} : _instance$node$config;
        const _Object$keys = Object.keys((_values$result = values.result) !== null && _values$result !== void 0 ? _values$result : {}),
          _Object$keys2 = _slicedToArray(_Object$keys, 1),
          form = _Object$keys2[0];
        // NOTE: validate status
        if (instance.status !== _constants.JOB_STATUS.PENDING || instance.job.status !== _constants.JOB_STATUS.PENDING || instance.execution.status !== _constants.EXECUTION_STATUS.STARTED || !instance.workflow.enabled || !((_forms$form = forms[form]) === null || _forms$form === void 0 ? void 0 : (_forms$form$actions = _forms$form.actions) === null || _forms$form$actions === void 0 ? void 0 : _forms$form$actions.includes(values.status))) {
          return context.throw(400);
        }
        instance.execution.workflow = instance.workflow;
        const processor = plugin.createProcessor(instance.execution, {
          transaction
        });
        yield processor.prepare();
        const assignees = processor.getParsedValue((_instance$node$config2 = instance.node.config.assignees) !== null && _instance$node$config2 !== void 0 ? _instance$node$config2 : []);
        if (!assignees.includes(currentUser.id) || instance.userId !== currentUser.id) {
          return context.throw(403);
        }
        // NOTE: validate assignee
        yield instance.update({
          status: values.status,
          result: values.result
        }, {
          transaction
        });
        return instance;
      });
      return function (_x3) {
        return _ref.apply(this, arguments);
      };
    }());
    // await transaction.commit();
    context.body = userJob;
    context.status = 202;
    yield next();
    userJob.job.latestUserJob = userJob;
    // NOTE: resume the process and no `await` for quick returning
    plugin.resume(userJob.job);
  });
  return _submit.apply(this, arguments);
}