"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _server() {
  const data = require("@nocobase/server");
  _server = function _server() {
    return data;
  };
  return data;
}
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
const calculatorsMap = {
  equal: '==',
  '===': '==',
  notEqual: '!=',
  '!==': '!=',
  gt: '>',
  gte: '>=',
  lt: '<',
  lte: '<=',
  includes(a, b) {
    return `SEARCH('${b}', '${a}') >= 0`;
  },
  notIncludes(a, b) {
    return `SEARCH('${b}', '${a}') < 0`;
  },
  startsWith(a, b) {
    return `SEARCH('${b}', '${a}') == 0`;
  },
  endsWith(a, b) {
    return `RIGHT('${a}', LEN('${b}')) == '${b}'`;
  },
  notStartsWith(a, b) {
    return `SEARCH('${b}', '${a}') != 0`;
  },
  notEndsWith(a, b) {
    return `RIGHT('${a}', LEN('${b}')) != '${b}'`;
  }
};
function migrateConfig({
  group: {
    type = 'and',
    calculations = []
  }
}) {
  return {
    group: {
      type,
      calculations: calculations.map(({
        calculator = '===',
        operands = []
      }) => {
        return `(${operands.map(operand => (operand === null || operand === void 0 ? void 0 : operand.group) ? migrateConfig(operand) : operand).join(` ${calculatorsMap[calculator]} `)})`;
      })
    }
  };
}
class _default extends _server().Migration {
  up() {
    var _this = this;
    return _asyncToGenerator(function* () {
      const match = yield _this.app.version.satisfies('<0.9.0-alpha.3');
      if (!match) {
        return;
      }
      const NodeRepo = _this.context.db.getRepository('flow_nodes');
      yield _this.context.db.sequelize.transaction( /*#__PURE__*/function () {
        var _ref = _asyncToGenerator(function* (transaction) {
          const nodes = yield NodeRepo.find({
            filter: {
              type: 'condition'
            },
            transaction
          });
          console.log('%d nodes need to be migrated.', nodes.length);
          yield nodes.reduce((promise, node) => promise.then(() => {
            return node.update({
              config: _objectSpread(_objectSpread({}, node.config), {}, {
                engine: 'basic'
                // calculation: migrateConfig(node.config.calculation)
              })
            }, {
              transaction
            });
          }), Promise.resolve());
        });
        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    })();
  }
}
exports.default = _default;